/* Copyright (c) 2007 Michele Bini
 * 
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA */

#ifndef __CURVE25519_H__
#define __CURVE25519_H__

#include <gmp.h>

#define C25519BITS 256
#define C25519USEDBITS (C25519BITS - 1)
#define C25519N (C25519BITS/32)
typedef mp_limb_t curve25519key_t[C25519N];

extern void curve25519(curve25519key_t *r, curve25519key_t *f, curve25519key_t *c);
extern int getbit(curve25519key_t *x, unsigned int n);
extern void setbit(curve25519key_t *x, unsigned int n, int v);
extern unsigned int getbyte(curve25519key_t *x, unsigned int n);
extern void setbyte(curve25519key_t *x, unsigned int n, unsigned int v);


#endif /* __CURVE25519_H__ */
