#include <stdio.h>
#include <stdlib.h>
#include "curve25519.h"
#include "base32.h"

int main(int argc, const char *argv[]) {
  char s[(C25519BITS/4)+2];
  curve25519key_t c, f, r;
  if (argc != 3) {
    fprintf(stderr, "Usage: %s base32encodedprivatekey base32encodedpublickey\n", argv[0]);
    exit(EXIT_FAILURE);
  }
  base32_decode(argv[1], &f);
  base32_decode(argv[2], &c);
  curve25519(&r, &f, &c);
  base32_encode(s, &r); printf("%s\n", s);
  exit(EXIT_SUCCESS);
}
